/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2007 The LS-Universe Team

  Homepage: http://www.ls-universe.info

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

/***************************************************************************
****************************************************************************

  Original source -> BadJerry <-

  Link: http://www.codeproject.com/gdi/htmldrawer.asp

  Completely Redone by Andymon

****************************************************************************
****************************************************************************/

#include "StdAfx.h"
#include "HTMLFont.h"

#ifndef CLEARTYPE_QUALITY
	#define CLEARTYPE_QUALITY       5
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CHTMLFont::CHTMLFont() :
	m_rgbColor(0),
	m_strName("Arial"),
	m_dSize(15),
	m_isBold(false),
	m_isItalic(false),
	m_isUnderline(false),
	m_isSmooth(true),
	m_nCharSet(0)
{
	m_isClearType = (IsOS(OS_XP) ? true : false);
}

CHTMLFont::~CHTMLFont()
{
}

CHTMLFont::CHTMLFont(const CHTMLFont & fnt)
{
	CopyProperties(fnt);
}

CHTMLFont & CHTMLFont::operator =(const CHTMLFont & fnt)
{
	if ( this != &fnt )
		CopyProperties(fnt);

	return *this;
}

void CHTMLFont::CopyProperties(const CHTMLFont & fnt)
{
	m_strName 		= fnt.m_strName;
	m_dSize 		= fnt.m_dSize;
	m_isBold 		= fnt.m_isBold;
	m_isItalic 		= fnt.m_isItalic;
	m_isUnderline 	= fnt.m_isUnderline;
	m_isSmooth		= fnt.m_isSmooth;
	m_isClearType   = fnt.m_isClearType;
	m_nCharSet 		= fnt.m_nCharSet;
	m_rgbColor 		= fnt.m_rgbColor;
}


void CHTMLFont::DeleteArray(CObArray & arrArray)
{
	for ( int nObj=0; nObj < arrArray.GetSize(); nObj++ )
		delete (CHTMLFont *) arrArray[nObj];
	arrArray.RemoveAll();
}

CFont* CHTMLFont::GetFont(CDC * pDC) const
{
	CFont *pFont = new CFont;

	int lfHeight = (int) m_dSize;

	if ( IsOS( OS_XP ) && m_isClearType )
		pFont->CreateFont( lfHeight, 0, 0, 0, m_isBold ? FW_BOLD : FW_NORMAL, m_isItalic, m_isUnderline, 0, (BYTE) m_nCharSet, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, (m_isSmooth ? CLEARTYPE_QUALITY : NONANTIALIASED_QUALITY), DEFAULT_PITCH, m_strName);
	else
		pFont->CreateFont( lfHeight, 0, 0, 0, m_isBold ? FW_BOLD : FW_NORMAL, m_isItalic, m_isUnderline, 0, (BYTE) m_nCharSet, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, (m_isSmooth ? ANTIALIASED_QUALITY : NONANTIALIASED_QUALITY), DEFAULT_PITCH, m_strName);

	return pFont;
}
